stages:
- test
- dump schema
- deploy
- release

include:
  - project: openraven/open/gitlab-ci
    file:
      - /docker-ecr-push.yml

variables:
  ECR_DOCKER_IMAGE: "${AWS_ECR_REGISTRY}/${CI_PROJECT_PATH}:${CI_PIPELINE_ID}"
  POSTGRES_USER: root
  POSTGRES_PASSWORD: sekrit
  POSTGRES_DB: orvn
  SCHEMA_FILE: database-schema.sql
  SQITCH_PLAN: sqitch.plan


test migration:
  stage: test
  services:
  - name: $CI_REGISTRY_IMAGE:orvn-13.10
    alias: pg
  image:
    name: $CI_REGISTRY_IMAGE:sqitch.with-git
    entrypoint: [ /usr/bin/env ]
  script:
  - git fetch origin
  - git checkout $CI_DEFAULT_BRANCH
  - sqitch deploy --verify
  - git checkout $CI_COMMIT_REF_NAME
  - sqitch deploy --verify
  - sqitch revert -y --to $(tail -3 sqitch.plan | sed '/^@/d' | head -1 | cut -d" " -f1)@HEAD
  - sqitch deploy --verify
  - psql -U root -h pg -d orvn -c "drop function calculate_word_frequencies" # this function code fails in testcontainers init function
  - pg_dump -U root -h pg orvn -f $SCHEMA_FILE -s -O -x -N sqitch
  variables:
    SQITCH_TARGET: postgresql://pg:5432/$POSTGRES_DB
    SQITCH_USERNAME: $POSTGRES_USER
    SQITCH_PASSWORD: $POSTGRES_PASSWORD
    PGPASSWORD: $POSTGRES_PASSWORD
  artifacts:
    paths:
      - $SCHEMA_FILE
    expire_in: 10 minutes
  rules:
    - if: $SKIP_TESTS == "true"
      when: never
    - when: always

dump schema:
  image: maven:3-jdk-11
  stage: dump schema
  script:
    - set -euo pipefail
    - cur_ver=$(mvn --batch-mode --quiet help:evaluate -Dexpression=project.version -DforceStdout=true)
    - next_ver=$(echo $cur_ver | grep -Eo '^[0-9]+\.[0-9]+\.')${CI_PIPELINE_ID}
    - mvn -Dmaven.repo.local=$PWD/.m2/repository -B versions:set -DgenerateBackupPoms=false -DnewVersion=${next_ver}
    - mvn -Dmaven.repo.local=$PWD/.m2/repository -B -s $GITLAB_MAVEN_SETTINGS_XML deploy

build and push image:
  stage: deploy
  extends: .build-ecr-image
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      when: always
    - if: $WITH_DOCKER_IMAGE != null && $WITH_DOCKER_IMAGE != ""
      when: always
    - when: never
  variables:
    PUBLIC_DOCKER_IMAGE: "${CI_REGISTRY_IMAGE}:${CI_PIPELINE_ID}"
    BUILDX_BUILD_EXTRA_ARGS: "--label io.openraven.branch=${CI_COMMIT_REF_NAME}"

build and push schema image:
  stage: deploy
  extends: .build-ecr-image
  variables:
    PUBLIC_DOCKER_IMAGE: "${CI_REGISTRY_IMAGE}:pg-with-schema.${CI_PIPELINE_ID}"
    ECR_DOCKER_IMAGE: "${AWS_ECR_REGISTRY}/${CI_PROJECT_PATH}:pg-with-schema.${CI_PIPELINE_ID}"
    BUILDX_BUILD_EXTRA_ARGS: "-f Dockerfile.pg-with-schema --label io.openraven.branch=${CI_COMMIT_REF_NAME}"
    BUILD_ARM64: "false"

release to staging:
  stage: release
  only:
    refs:
      - main
  trigger:
    project: openraven/open/helm-charts/helmfiles
    strategy: depend # Add this to attempt to fail the build.
  variables:
    HELMFILE_NAME: 'database-schema.yaml'
    CHART_NAME: 'database-schema'
    UPSTREAM_TAG: "${CI_PIPELINE_ID}"
